#include "ot4xb.ch"
// ---------------------------------------------------------------------------
BEGIN STRUCTURE _SH_F_OP_Mapping_Entry_
   MEMBER LPSTR pszOldPath
   MEMBER LPSTR pszNewPath
   MEMBER int cchOldPath
   MEMBER int cchNewPath
END STRUCTURE
// ---------------------------------------------------------------------------
BEGIN STRUCTURE _SH_F_OP_Mappings_
   MEMBER LONG n
   MEMBER POINTER32 p
END STRUCTURE
// ---------------------------------------------------------------------------
BEGIN STRUCTURE _SH_F_OP_Base_
   MEMBER HWND      hWnd
   MEMBER UINT      nOp
   MEMBER LPSTR     pFrom
   MEMBER LPSTR     pTo
   MEMBER WORD      wFlags
   MEMBER BOOL      lCancel
   MEMBER POINTER32 pMappings
   MEMBER LPSTR     pTitle
END STRUCTURE
// ---------------------------------------------------------------------------
CLASS TShFileOperation FROM _SH_F_OP_Base_
EXPORTED:
   VAR cFrom
   VAR cTo
   VAR cTitle
   VAR aMap
       // --------------------------------------------------------------------
   INLINE METHOD Move()   ; ::nOp := 0x0001 ; return ( ::Start() == 0 )
   INLINE METHOD Copy()   ; ::nOp := 0x0002 ; return ( ::Start() == 0 )
   INLINE METHOD Delete() ; ::nOp := 0x0003 ; return ( ::Start() == 0 )
   INLINE METHOD Rename() ; ::nOp := 0x0004 ; return ( ::Start() == 0 )
       // --------------------------------------------------------------------
   INLINE METHOD Reset()  
          ::cFrom := ::cTo := ::cTitle := ::aMap := NIL
          ::_zeromemory_()
          return Self
       // --------------------------------------------------------------------
   PROPERTY fMultiDestFiles         IS MASK 0x0001  OF wFlags
   PROPERTY fConfirmMouse           IS MASK 0x0002  OF wFlags
   PROPERTY fSilent                 IS MASK 0x0004  OF wFlags
   PROPERTY fRenameOnCollision      IS MASK 0x0008  OF wFlags
   PROPERTY fNoConfirmation         IS MASK 0x0010  OF wFlags
   PROPERTY fWantMappingHandle      IS MASK 0x0020  OF wFlags
   PROPERTY fAllowUndo              IS MASK 0x0040  OF wFlags
   PROPERTY fFilesOnly              IS MASK 0x0080  OF wFlags
   PROPERTY fSimpleProgress         IS MASK 0x0100  OF wFlags
   PROPERTY fNoConfirmMkDir         IS MASK 0x0200  OF wFlags
   PROPERTY fNoErrorUI              IS MASK 0x0400  OF wFlags
   PROPERTY fNoCopySecurityAttribs  IS MASK 0x0800  OF wFlags
   PROPERTY fNoRecursion            IS MASK 0x1000  OF wFlags
   PROPERTY fNoConnectedElements    IS MASK 0x2000  OF wFlags
   PROPERTY fWantNukeWarning        IS MASK 0x4000  OF wFlags
   PROPERTY fNoRecurseReparse       IS MASK 0x8000  OF wFlags
   // --------------------------------------------------------------------
   INLINE CLASS METHOD initClass(); return Self  
   // --------------------------------------------------------------------
   INLINE METHOD Start()
   local lOk := .F.
   local lFrom   := .F.
   local lTo     := .F.
   local lTitle  := .F.
   if ( ::nOp < 1 ) .or. ( ::nOp > 4 )  ; return .F. ;  end
   ::lCancel    := .F.
   ::pMappings  := 0
   ::aMap       := NIL
   if(::pFrom  == 0); ::pFrom  := Array2pszz( ::cFrom ); lFrom  := .T. ; end
   if( ::nOp == 0x0003 ) 
      if( ::pTo   != 0) ; _xfree(::pTo  ) ; ::pTo   := 0 ; end
   else
      if(::pTo    == 0); ::pTo    := Array2pszz( ::cTo   ); lTo    := .T. ; end
   end
   if((::cTitle != NIL) .and. (::pTitle == 0))
      ::pTitle := _xgrab( ::cTitle )
      lTitle := .T.
   end
   lOk := @Shell32:SHFileOperationA( Self )
   if lTitle ; _xfree( ::pTitle ) ; ::pTitle := 0 ;  end
   if lFrom  ; if( ::pFrom != 0) ; _xfree(::pFrom) ; ::pFrom := 0 ; end ; end
   if lTo    ; if( ::pTo   != 0) ; _xfree(::pTo  ) ; ::pTo   := 0 ; end ; end
   if ::pMappings != 0
      ::ParseMapings()            
      @Shell32:SHFreeNameMappings(::pMappings )
      ::pMappings := 0
   end
   return lOk
   // --------------------------------------------------------------------
INLINE METHOD ParseMapings()
   local oMaps     := _SH_F_OP_Mappings_():New()
   local oItem     := _SH_F_OP_Mapping_Entry_():New()
   local nItemSize := oItem:_sizeof_()
   local nItems,n,p,cc

   oMaps:_link_( ::pMappings , .F. )
   nItems    := oMaps:n
   ::aMap := Array( nItems , 2 )
   p := oMaps:p
   if lIsWin9x()
      for n := 1 to nItems
         oItem:_link_(p , .F.)
         ::aMap[n][1] := PeekStr(oItem:pszOldPath,0,oItem:cchOldPath)
         ::aMap[n][2] := PeekStr(oItem:pszNewPath,0,oItem:cchNewPath)
         p += nItemSize
      next
   else
      for n := 1 to nItems
         oItem:_link_(p , .F.)
         cc := PeekStr(oItem:pszOldPath,0,oItem:cchOldPath * 2) + Chrr(0,2)
         ::aMap[n][1] := cSzWide2Ansi( @cc )
         cc := PeekStr(oItem:pszNewPath,0,oItem:cchNewPath * 2) + Chrr(0,2)
         ::aMap[n][2] := cSzWide2Ansi( @cc )
         p += nItemSize
      next
   end
return NIL
       // --------------------------------------------------------------------
ENDCLASS
